//-------------------------------------------------------------------------------------------------+
// Localization.h
// ȈʒusRTR|[lg̃CNX`
//-------------------------------------------------------------------------------------------------+

#ifndef LOCALIZATION_H
#define LOCALIZATION_H

#include "SKSLAM/KSLAM.h"
typedef RangeData  SlamRangeData;
typedef StereoData SlamStereoData;

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service Consumer stub headers
#include "MRFCStub.h"
#include "LaserRangeSensorDataStub.h"
#include "IIS2Stub.h"
#include "StereoCameraServiceStub.h"

#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include <vector>

// ΐlnɂȂꂽ_wb_t@CCN[hĒ܂
#include "TIMER_CLASS.h"


// 摜TCY̒`
#define IMG_WIDTH (512)
#define IMG_HEIGHT (384)


using namespace RTC;
using namespace SensorRTC::LaserRangeSensor::idl;
using namespace IIS;
using namespace TUT;
using namespace MRFC;


//-------------------------------------------------------------------------------------------------+
// ǂݍ񂾎Ȉʒup̒n}f[^ڂ߂̈ꎞIȃf[^i[pNX
//-------------------------------------------------------------------------------------------------+
class MapDataForMCL{
public:
	vector<vector<vector<vector<double>>>> map;
	Pose pose;
	bool initial_pose;

	MapDataForMCL();
	void SetInitialPose( Pose pose );
	GlobalMap *GenerateGlobalMap( TimedFloatAbsoluteOGMapData *mapdata, int particle_num );
};


//-------------------------------------------------------------------------------------------------+
// Localization
//-------------------------------------------------------------------------------------------------+
class Localization : public RTC::DataFlowComponentBase{
public:
	Localization(RTC::Manager* manager);
	~Localization();
	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:
	int m_Particle_num;
	int m_debug_window;
	int m_USE_INIT_POSE;
	double m_INIT_X;
	double m_INIT_Y;
	double m_INIT_HEADING;

	// DataInPort declaration
	TimedMeasuredData m_RangeData;
	InPort<TimedMeasuredData> m_RangeDataIn;
	IIS::TimedPose2D m_RobotPose;
	InPort<IIS::TimedPose2D> m_RobotPoseIn;
	TimedImageData m_Image;
	InPort<TimedImageData> m_ImageIn;
	TimedStereoData m_StereoData;
	InPort<TimedStereoData> m_StereoDataIn;

	// DataOutPort declaration
	IIS::TimedPose2D m_EstimatedPose;
	OutPort<IIS::TimedPose2D> m_EstimatedPoseOut;
	MRFC::TimedEstimatedPose2D m_PosePair;
	OutPort<MRFC::TimedEstimatedPose2D> m_PosePairOut;

	// CORBA Port declaration
	RTC::CorbaPort m_AbsoluteMapServicePort;

	// Consumer declaration
	RTC::CorbaConsumer<MRFC::AbsoluteMapService> m_AbsoluteMapService;

private:
	SLAMinput *input;
	KSLAM *kslam;
	TIMER::TIMER_CLASS *cTimer;

	bool InputPose();
	bool InputLRF();
	bool InputStereo();
	void OutputPose();
	IplImage* TimedImageData2IplImage( TimedImageData *data );
	bool CheckServicePort();
	TimedFloatAbsoluteOGMapData *GetMapData();
	GlobalMap *InitGlobalMap();
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void LocalizationInit(RTC::Manager* manager);
};

#endif // LOCALIZATION_H
