//------------------------------------------------------------------------------------------------+
// Filename: BasicClass.h
// Content : {IȃNXQ̒`
//------------------------------------------------------------------------------------------------+
#ifndef __BASICCLASS
#define __BASICCLASS

#include <vector>

//------------------------------------------------------------------------------------------------+
// 萔̒`
//------------------------------------------------------------------------------------------------+
const double rad_to_deg = 180.0 / 3.14159265358979323846;
const double deg_to_rad = 3.14159265358979323846 / 180.0;


//------------------------------------------------------------------------------------------------+
// 2WNX̒`
//------------------------------------------------------------------------------------------------+
class Coordinate{
public:
	double x, y;

	Coordinate(){ x = y = 0.0; }
	Coordinate( double x, double y ){ this->x = x;  this->y = y; }

	bool operator==( Coordinate c );
	bool operator!=( Coordinate c );
	Coordinate& operator+=( Coordinate c );
	Coordinate& operator-=( Coordinate c );
	Coordinate& operator*=( double f );
	Coordinate& operator/=( double f );
	Coordinate operator+( Coordinate c );
	Coordinate operator-( Coordinate c );
	Coordinate operator*( double f );
	Coordinate operator/( double f );
	Coordinate operator-();
};


//------------------------------------------------------------------------------------------------+
// 2ʒuf[^NX
//------------------------------------------------------------------------------------------------+
class Pose : public Coordinate{
public:
	double angle;	// [rad]
	Pose(){ x = y = angle = 0.0; }
	Pose( double x, double y, double angle ):Coordinate( x, y ){ this->angle = angle; }
};


//------------------------------------------------------------------------------------------------+
// f[^NX
//------------------------------------------------------------------------------------------------+
class RangeData{
public:
	double max_angle, min_angle;
	int max_data;
	std::vector<double> value;
	RangeData(){ max_angle = min_angle = 0.0; max_data = 0; }
};


//------------------------------------------------------------------------------------------------+
// XeIf[^NX
//------------------------------------------------------------------------------------------------+
class StereoData{
public:
	int image_width, image_height;

	// double value[(int)IMG_WIDTH][(int)IMG_HEIGHT][3];
	std::vector<std::vector<std::vector<double>>> value;

	StereoData(){ image_width = image_height = 0; }

	StereoData( int width, int height ){

		image_width  = width;
		image_height = height;

		value.resize( width );
		for( int i=0; i<width; i++ ){
			value[i].resize( height );
			for( int j=0; j<height; j++ ){
				value[i][j].resize( 3 );
				for( int k=0; k<3; k++ ) value[i][j][k] = -1.0;
			}
		}
	}
};


#endif	//__BASICCLASS
