//------------------------------------------------------------------------------------------------+
// Filename: LocalMap.cpp
// Content : Ǐn}NX̃o֐
//------------------------------------------------------------------------------------------------+

#include "LocalMap.h"
#define _USE_MATH_DEFINES
#include <math.h>


//------------------------------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
LocalMap::LocalMap(){

	reset_map();

	count.resize( LOCALMAP_WIDTH );
	for( int i=0; i<LOCALMAP_WIDTH; i++ ) count[i].resize( LOCALMAP_HEIGHT );
}


//------------------------------------------------------------------------------------------------+
// n}̃Zbg
//------------------------------------------------------------------------------------------------+
void LocalMap::reset_map(){

	for( int i=0; i<LOCALMAP_WIDTH; i++ ) for( int j=0; j<LOCALMAP_HEIGHT; j++){

		atlas[i][j] = INITIAL_MAP_VALUE;
	}
}


//------------------------------------------------------------------------------------------------+
// Ŏw肳ꂽʒu܂ł̈ړʕn}𓮂
//------------------------------------------------------------------------------------------------+
void LocalMap::move_map( Pose current_pose ){

	// {bg̈ړʂ]ʂvZ
	Pose moved = Pose( current_pose.x - world.x, current_pose.y - world.y, current_pose.angle - world.angle );

	double distance  = sqrt( moved.x * moved.x + moved.y * moved.y );

	double th = atan2( moved.y, moved.x );

	double di = distance * cos( th - current_pose.angle );	//x
	double dj = distance * sin( th - current_pose.angle );	//y

	double sin_value = sin( moved.angle );
	double cos_value = cos( moved.angle );


	// ]n}Udumy}bvɓ
	double dumy[LOCALMAP_WIDTH][LOCALMAP_HEIGHT];
	for ( int j=0; j<LOCALMAP_HEIGHT; j++) for( int i=0; i<LOCALMAP_WIDTH; i++){

		// ]ȎΉWvZ
		Coordinate old;
		old.x = ( i - LOCALMAP_WIDTH / 2) * cos_value - ( j - LOCALMAP_HEIGHT / 2 ) * sin_value + LOCALMAP_HEIGHT / 2;
		old.y = ( i - LOCALMAP_WIDTH / 2) * sin_value + ( j - LOCALMAP_HEIGHT / 2 ) * cos_value + LOCALMAP_WIDTH / 2;
		old.x = old.x + di / L_grid_size;
		old.y = old.y + dj / L_grid_size;

		if ( old.x > 1 && old.x < (LOCALMAP_WIDTH-1) && old.y > 1 && old.y < ( LOCALMAP_HEIGHT - 1 ) ){

			Coordinate odd( old.x - (int)old.x, old.y - (int)old.y );

			dumy[i][j] = ( 1 - odd.x ) * ( 1 - odd.y ) * atlas[(int)old.x][(int)old.y]
					   + odd.x * ( 1 - odd.y ) * atlas[(int)old.x + 1][(int)old.y]
					   + ( 1 - odd.x ) * (odd.y) * atlas[(int)old.x][(int)old.y + 1]
					   + (odd.x) * (odd.y) * atlas[(int)old.x + 1][(int)old.y + 1];
		}
		else dumy[i][j] = INITIAL_MAP_VALUE;
	}


	for( int j=0; j<LOCALMAP_HEIGHT; j++) for( int i=0; i<LOCALMAP_WIDTH; i++ ) atlas[i][j] = dumy[i][j];

	world = current_pose; 
}


//------------------------------------------------------------------------------------------------+
// Ǐn}̕`
// xy͊JnW
//------------------------------------------------------------------------------------------------+
void LocalMap::show_LocalMap( IplImage* img, int img_x, int img_y ){

	for( int y= 0; y <LOCALMAP_HEIGHT; y++) for( int x = 0; x <LOCALMAP_WIDTH; x++){

		int densityA = (int)( 255 * get_atlas( x, y ) + 0.5 );
		if( !( 0 <= densityA && 256 > densityA )) densityA = 0;

		int j = LOCALMAP_HEIGHT - x + img_y;
		int i = LOCALMAP_WIDTH  - y + img_x;

		(img)->imageData[(img)->widthStep * j + i * 3]     = (densityA);
		(img)->imageData[(img)->widthStep * j + i * 3 + 1] = (densityA);
		(img)->imageData[(img)->widthStep * j + i * 3 + 2] = (densityA);
	}
}


//------------------------------------------------------------------------------------------------+
// LocalMap ̐Lϑ̍XV
//
// 1̊ϑ͈͂`ƍlA̗[̕ӂ̐̃ZLϑƂčXV
// ܂A`𔼕ɂ邱ƂJԂƂŐ`̌ʂ̏ɂZSĂXV
// L͍̏ċAgčsA`𔼕ɂĂAӂZ悤ɂȂI
//------------------------------------------------------------------------------------------------+
void LocalMap::update_occupancy_grid( double d, double max_fai, double min_fai, double dis_fai, double max_angle, double min_angle ){

	 // d͊ϑ̋@v̊px(max_fai-min_fai)ŕӂ̑傫d̐`l
	 int y  = (int)( LOCALMAP_HEIGHT / 2 - d * sin( -( max_fai + min_angle ) * M_PI / 180.0 ));
	 int x  = (int)( LOCALMAP_WIDTH  / 2 + d * cos( -( max_fai + min_angle ) * M_PI / 180.0 ));

	 int y2 = (int)( LOCALMAP_HEIGHT / 2 - d * sin( -( min_fai + min_angle ) * M_PI / 180.0 ));
	 int x2 = (int)( LOCALMAP_WIDTH  / 2 + d * cos( -( min_fai + min_angle ) * M_PI / 180.0 ));


	 // `̐悪Zꍇ͍ċAXgbv
	 if( x == x2 && y == y2 ){

		 //XV}bv@̊ϑōXV1@(łɍXVĂꍇcount[x][y]==1)
		 if( x < LOCALMAP_WIDTH && x > 0 && y < LOCALMAP_HEIGHT && y > 0 && count[x][y] == 0 ){

			 atlas[x][y] = ( poe(d) * atlas[x][y] ) / ( poe(d) * atlas[x][y] + poe_(d) * ( 1 - atlas[x][y] ));
			 count[x][y] = 1;
		 }
	 }

	 // `̐悪ႤZꍇ͐`𔼕ɂčċA
	 else{
		 update_occupancy_grid( d, max_fai, max_fai - dis_fai, dis_fai / 2.0, max_angle, min_angle );
		 update_occupancy_grid( d, min_fai, min_fai + dis_fai, dis_fai / 2.0, max_angle, min_angle );
	 }
}


//------------------------------------------------------------------------------------------------+
// LocalMap ̋󂫊ϑ̍XV
//
// {Iɂ͐L̊֐Ɠ
// ӂ̑傫0`d|0.5[Z]̊ԂŁ{0.5ȂċAs`̒󂫊ϑŖ߂
//------------------------------------------------------------------------------------------------+
void LocalMap::update_free_grid( double d, double d_max, double max_fai, double min_fai, double dis_fai, double max_angle, double min_angle ){

	 int y  =(int)( LOCALMAP_HEIGHT / 2 - d * sin( -( max_fai + min_angle ) * M_PI / 180 ) + 0.5 );
	 int x  =(int)( LOCALMAP_WIDTH  / 2 + d * cos( -( max_fai + min_angle ) * M_PI / 180 ) + 0.5 );
	 int y2 =(int)( LOCALMAP_HEIGHT / 2 - d * sin( -( min_fai + min_angle ) * M_PI / 180 ) + 0.5 );
	 int x2 =(int)( LOCALMAP_WIDTH  / 2 + d * cos( -( min_fai + min_angle ) * M_PI / 180 ) + 0.5 );

	 if( x == x2 && y == y2 ){

		if( !( x < LOCALMAP_WIDTH && x >= 0 && y < LOCALMAP_HEIGHT && y >= 0 )) return;

		//XV}bv@̊ϑōXV1@(łɍXVĂꍇcount[x][y]==1)
		if( count[x][y] == 0 ){

			 atlas[x][y] = ( po_e(d) * atlas[x][y] ) / ( po_e(d) * atlas[x][y] + po_e_(d) * ( 1 - atlas[x][y] ));
			 count[x][y] = 2;

			 // ̕ӂ̒d-0.5 ɂȂ܂ōċA
			 if( d_max > d ) update_free_grid( d + 0.5, d_max, max_fai, min_fai, dis_fai, max_angle, min_angle );
		}
		else if( count[x][y] == 1 ) return;
		else if( d_max > d ) update_free_grid( d + 0.5, d_max, max_fai, min_fai, dis_fai, max_angle, min_angle);
	 }

	 else{

		 if( dis_fai > 0.1 ){
			 update_free_grid( d, d_max, max_fai, max_fai-dis_fai, dis_fai / 2.0, max_angle, min_angle );
			 update_free_grid( d, d_max, min_fai + dis_fai, min_fai, dis_fai / 2.0, max_angle, min_angle );
		 }

		 //قڒɂȂFIɏI
		 else{
			 update_free_grid( d, d_max, max_fai, max_fai, 0, max_angle, min_angle);
			 update_free_grid( d, d_max, min_fai, min_fai, 0, max_angle, min_angle);
			 update_free_grid( d, d_max, min_fai + dis_fai, min_fai + dis_fai, 0, max_angle, min_angle);
		 }
	 }
}


//------------------------------------------------------------------------------------------------+
// Ǐn}XVp
//------------------------------------------------------------------------------------------------+
void LocalMap::input_data( int max_data, double max_angle, double min_angle, vector<double> po, double max_range ){

	double *data = new double[po.size()];

	for( int i=0; i<(int)po.size(); i++) data[i] = po[i];

	input_data( max_data, max_angle, min_angle, data, max_range );

	delete data;
}


//------------------------------------------------------------------------------------------------+
// Ǐn}XVp
//------------------------------------------------------------------------------------------------+
void LocalMap::input_data( int max_data, double max_angle, double min_angle, double *po, double max_range ){

	double dangle = ( max_angle - min_angle ) / ((double)max_data);		//px\vZ
	int flag3 = 0;

	reset_count();


	// ȉ̏ŐLZ̍XVɍsȂ̂͐LϑD悷邽

	// LϑXV֐
	for( int i=0; i<max_data; i++){

		double d = po[i] / L_grid_size;

		if( po[i] > max_range ){
			po[i] = -1;
			d = -1;
		}

		if( po[i] > min_range ){

			double fai = dangle * i;

			if( !((int)( d + 0.5 ) >= (int)( max_range / L_grid_size + 0.5 ))){

				update_occupancy_grid( d, fai + dangle / 2.0, fai - dangle / 2.0, dangle / 4.0, max_angle, min_angle );
			}
		}
	}

	// 󂫊ϑXV֐
	for( int i=0; i < max_data; i++ ){

		double d = po[i] / L_grid_size;

		if( po[i] > min_range ){

			double fai = dangle * i;

			flag3 = 0;
			d -= 0.5;

			update_free_grid( 0, d, fai + dangle / 2.0, fai - dangle / 2.0, dangle / 4.0, max_angle, min_angle );
		}
	}
}


//------------------------------------------------------------------------------------------------+
// Ǐn}̃Rs[sȂ
//------------------------------------------------------------------------------------------------+
void LocalMap::copy_LocalMap( LocalMap* origin ){

	for( int i=0; i<LOCALMAP_WIDTH; i++ ) for( int j=0; j<LOCALMAP_HEIGHT; j++ ){
		
		atlas[i][j] = origin->atlas[i][j];
	}
}
