//------------------------------------------------------------------------------------------------+
// Filename: LocalMap.h
// Content : Ǐn}NX̒`
//------------------------------------------------------------------------------------------------+

#ifndef __LOCALMAP__
#define __LOCALMAP__

#include "cv.h"
#include "highgui.h"
#include "BasicClass.h"
#include <vector>

using namespace std;


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define LOCALMAP_WIDTH (300)
#define LOCALMAP_HEIGHT (300)
#define L_grid_size (50)
#define min_range (100)
#define range_dangle (600)
#define STEREO_SENSOR_END (28.0)
#define STEREO_SENSOR_START (-28.0)
#define STEREO_SENSOR_RANGE (8000.0)
#define INITIAL_MAP_VALUE	(0.5)


//------------------------------------------------------------------------------------------------+
// Ǐn}NX
//------------------------------------------------------------------------------------------------+
class LocalMap{
private:
	double atlas[LOCALMAP_WIDTH][LOCALMAP_HEIGHT];		//Z̑݊̕m

	Pose world;					// ݂̃{bgʒu(΍W)

public: 
	vector<vector<int>> count;	// count͍XVtO@Z͈̊ϑň񂵂ۑȂ

	LocalMap();

	void reset_count(){
		for( int i=0; i<LOCALMAP_WIDTH; i++ ) for( int j=0; j<LOCALMAP_HEIGHT; j++ ) count[i][j] = 0;
	}

	double get_atlas( int x, int y ){

		if( x < 0 || y < 0 || LOCALMAP_WIDTH  <= x || LOCALMAP_HEIGHT <= y ) return INITIAL_MAP_VALUE;
		return atlas[x][y];
	}

	void set_world( double x, double y, double angle ){ world = Pose( x, y, angle ); }
	void set_world( Pose pose ){ world = pose; }

	double get_warld_x(){ return world.x; }
	double get_warld_y(){ return world.y; }
	double get_angle(){ return world.angle; }

	void reset_map();
	void move_map( Pose current_pose );
	void move_map( double x, double y, double angle ){ move_map( Pose( x, y, angle )); }

	void input_data( int max_data, double max_angle, double min_angle, vector<double> po, double max_range );
	void input_data( int max_data, double max_angle, double min_angle, double *po, double max_range );
	void show_LocalMap( IplImage* img, int img_x, int img_y );
	void update_free_grid( double d, double d_max, double max_fai, double min_fai, double dis_fai, double max_angle, double min_angle );
	void update_occupancy_grid( double d, double max_fai, double min_fai, double dis_fai, double max_angle, double min_angle );
	void copy_LocalMap( LocalMap* origin );

	// Ӗ̂킩Ȃ֐
	double poe( double d ){	return 1.0; }
	double poe_( double d ){ return 0.0; }
	double po_e( double d ){ return 1.0 - poe(d); }
	double po_e_( double d ){ return (1.0 - poe_(d)); }
};


#endif  // __LOCALMAP__
