//------------------------------------------------------------------------------------------------+
// Filename: SLAMinput.cpp
// Content : SLAMɓo͂f[^NX̊֐`
//------------------------------------------------------------------------------------------------+

#include "SLAMinput.h"
#include "landmark.h"
#include <cstdio>
#include <iostream>

#define	MAX_RANGE			30000		// [UZT̎擾\ő勗

#pragma warning ( disable : 4996 )

using namespace std;


//------------------------------------------------------------------------------------------------+
// ֐iRXgN^j
//------------------------------------------------------------------------------------------------+
SLAMinput::SLAMinput(){
	
	image_updated = stereo_updated = pose_updated = lrf_updated = false; 
	image = 0;
}


//------------------------------------------------------------------------------------------------+
// fXgN^
//------------------------------------------------------------------------------------------------+
SLAMinput::~SLAMinput(){

	cvReleaseImage( &image );		// ̊J
}


//------------------------------------------------------------------------------------------------+
// J摜Ԃ
//------------------------------------------------------------------------------------------------+
IplImage *SLAMinput::Image(){

	image_updated = false;
	return image;
}


//------------------------------------------------------------------------------------------------+
// XeIf[^Ԃ
//------------------------------------------------------------------------------------------------+
StereoData SLAMinput::Stereo(){

	stereo_updated = false;
	return stereo;
}


//------------------------------------------------------------------------------------------------+
// {bg̈ʒuEpԂ
//------------------------------------------------------------------------------------------------+
Pose SLAMinput::RobotPose(){

	pose_updated = false;
	return pose;
}


//------------------------------------------------------------------------------------------------+
// [UZT̎擾f[^Ԃ
//------------------------------------------------------------------------------------------------+
RangeData SLAMinput::LRFdata(){

	lrf_updated = false;
	return range;
}


//------------------------------------------------------------------------------------------------+
// 摜f[^󂯎
//------------------------------------------------------------------------------------------------+
void SLAMinput::SetData( IplImage *data ){

	if( !data ) return;
	cvReleaseImage( &image );
	image = data;
	image_updated = true;
}


//------------------------------------------------------------------------------------------------+
// XeIf[^󂯎
//------------------------------------------------------------------------------------------------+
void SLAMinput::SetData( StereoData data ){

	stereo = data;
	stereo_updated = true;
}


//------------------------------------------------------------------------------------------------+
// {bgʒuEpf[^󂯎
//------------------------------------------------------------------------------------------------+
void SLAMinput::SetData( Pose data ){

	pose = data;
	pose_updated = true;
}


//------------------------------------------------------------------------------------------------+
// [Uf[^󂯎
//------------------------------------------------------------------------------------------------+
void SLAMinput::SetData( RangeData data ){

	range = data;
	lrf_updated = true;
}


//*************************************************************************************************

//------------------------------------------------------------------------------------------------+
// ֐iRXgN^j
//------------------------------------------------------------------------------------------------+
SLAMinputFromLog::SLAMinputFromLog():SLAMinput(){

	data_number = 0;
	DataUpdate();
}


//------------------------------------------------------------------------------------------------+
// ̃f[^ǂݍōXV
// Vf[^ǂݍ߂Ȃꍇ͌Âf[^ێ܂
//------------------------------------------------------------------------------------------------+
bool SLAMinputFromLog::DataUpdate(){
	
	IplImage *temp_image;
	StereoData temp_stereo;
	Pose temp_pose;
	RangeData temp_range;

	temp_image  = GetImage( data_number );
	temp_stereo = ReadStereoData( data_number );
	temp_pose   = ReadPose( data_number );
	temp_range  = ReadRangeData( data_number );

	if( image_updated  ) image  = temp_image;
	if( stereo_updated ) stereo = temp_stereo;
	if( pose_updated   ) pose   = temp_pose;
	if( lrf_updated    ) range  = temp_range;

	data_number++;

	return IsNewAnyData();
}


//------------------------------------------------------------------------------------------------+
// w莞Ԃ̉摜t@Cǂݍ
//------------------------------------------------------------------------------------------------+
IplImage *SLAMinputFromLog::GetImage( int time ){

	char name[1000];
	sprintf_s( name, "data/image%06d.jpg", time );
	cerr << "Loading image " << name;

	cvReleaseImage( &image );

	IplImage *raw_image = cvLoadImage( name );

	if( raw_image ){

		image_updated = true;
		cerr << " is Finished.\n";
	}
	else cerr << " is NG!\n";

	return raw_image;
}


//------------------------------------------------------------------------------------------------+
// w莞Ԃ̃XeIf[^t@Cǂݍ
//------------------------------------------------------------------------------------------------+
StereoData SLAMinputFromLog::ReadStereoData( int time ){

	char buf[1000]; 
	FILE *fl;

	StereoData stereo( IMG_WIDTH, IMG_HEIGHT );

	// 擾
	sprintf_s( buf, "data/stereo%06d.txt", time );
	cerr << "Reading Stereo Data from " << buf;
	fl = fopen( buf, "rt" );

	double v1,v2,v3;
	int ID, data_num = 0;

	if( buf == NULL || !fl ){

		cerr << " is NG!\n";
		return stereo;
	}

	while(1){

		if( fgets( buf, sizeof(buf), fl ) == 0 ) break;

		sscanf_s( buf, "%lf %lf %lf %d", &v1, &v2, &v3, &ID );

		if( !( v3 < 0 )){

			int col = (int)( ID / IMG_WIDTH );
			int row = ( ID % IMG_WIDTH );

			stereo.value[row][col][0] = -v1 * 1000.0;
			stereo.value[row][col][1] =  v2 * 1000.0;
			stereo.value[row][col][2] =  v3 * 1000.0;
		}
	}

	fclose( fl );

	stereo_updated = true;

	cerr << " is Finished.\n";
	return stereo;
}


//------------------------------------------------------------------------------------------------+
// w莞Ԃ̈ʒuf[^t@Cǂݍ
//------------------------------------------------------------------------------------------------+
Pose SLAMinputFromLog::ReadPose( int time ){
	
	char buf[1000]; 
	FILE *fl;

	Pose pose;

	sprintf_s( buf, "data/pose%06d.txt", time );
	cerr << "Reading Robot Pose Data from " << buf;
	fl = fopen( buf, "rt" );

	if( !fl ){

		cerr << " is NG!\n";
		return pose;
	}

	if( fgets( buf, sizeof(buf), fl ) != 0 ) pose.x     = atof( buf ) * 1000;
	if( fgets( buf, sizeof(buf), fl ) != 0 ) pose.y     = atof( buf ) * 1000;
	if( fgets( buf, sizeof(buf), fl ) != 0 ) pose.angle = atof( buf );

	fclose( fl );

	pose_updated = true;

	cerr << " is Finished.\n";

	cerr << "pose( " << pose.x << ", " << pose.y << ", " << pose.angle << " )\n";

	return pose;
}


//------------------------------------------------------------------------------------------------+
// w莞Ԃ̋f[^t@Cǂݍ
//------------------------------------------------------------------------------------------------+
RangeData SLAMinputFromLog::ReadRangeData( int time ){

	char buf[1000];
	FILE *fl;
	RangeData range;
	char* stop = (char *)("\n");

	sprintf_s( buf, "data/lrf%06d.txt", time );
	cerr << "Reading LRF Range Data from " << buf;
	fl = fopen( buf, "rt" );

	if( !fl ){

		cerr << " is NG!\n";
		return range;
	}

	if( fgets( buf, sizeof(buf), fl ) != 0 ) range.min_angle = atof(buf) - 90;
	if( fgets( buf, sizeof(buf), fl ) != 0 ) range.max_angle = atof(buf) - 90;
	if( fgets( buf, sizeof(buf), fl ) != 0 ) range.max_data  = atoi(buf);

	while( fgets( buf, sizeof(buf), fl ) != 0 ){

		double value = strtod( buf, &stop );
		if( value < 10.0 || MAX_RANGE < value ) value = -1.0;
		range.value.push_back( value );
	}

	fclose( fl );

	if( range.max_data != (int)range.value.size() )  range.max_data = (int)range.value.size();

	lrf_updated = true;

	cerr << " is Finished.\n";

	return range;
}





