#include "edit_map.h"

/*2vZ*/
double sq(double x){
	return x*x;
}


/*@Kz*/
double nrand(){
	static int first=1;
	static int state=0;
	static double r1,r2;
	static double Z1,Z2;
	if(first==1){
		first=0;
		srand((unsigned)time(NULL));
	}
	if(state==0){
#if 0
		r1=((double)rand()+1)/((double)RAND_MAX+1);
		r2=((double)rand()+1)/((double)RAND_MAX+1);
#else
		r1=((double)rand())/((double)RAND_MAX);
		while(r1<1.0/RAND_MAX){
			r1=((double)rand())/((double)RAND_MAX);
		}
		r2=((double)rand())/((double)RAND_MAX);
#endif
		Z1=sqrt(-2*log(r1))*cos(2*M_PI*r2);
		Z2=sqrt(-2*log(r1))*sin(2*M_PI*r2);
		state=1;
		return Z1;
	}
	state=0;
	return Z2;


}


// 
double ran0() {
	return (double)rand()/((double)RAND_MAX+1);
}


// Obhn}p̍WvZ@΍W[΍W̌vZ
void change_coordinates( double x, double y, int* a ){

	double xd, yd;
	xd = x + 25.5 * G_MAP_size;
	yd = y + 25.5 * G_MAP_size;

	a[2] = (int)floor( xd / G_MAP_size );
	a[3] = (int)floor( yd / G_MAP_size );

	a[0] = (int)(( xd - (double)a[2] * G_MAP_size - (double)G_MAP_size/2 ) + 0.5 );
	a[1] = (int)(( yd - (double)a[3] * G_MAP_size - (double)G_MAP_size/2 ) + 0.5 );

	while( a[0] >= G_MAP_size/2 ){
		a[0] -= G_MAP_size;
		a[2]++;
	}

	while( a[0] < -G_MAP_size/2 ){
		a[0] += G_MAP_size;
		a[2]--;
	}

	while( a[1] >= G_MAP_size/2 ){
		a[1] -= G_MAP_size;
		a[3]++;
	}
	while( a[1] < -G_MAP_size/2 ){
		a[1] += G_MAP_size;
		a[3]--;
	}

	a[2] -= G_MAP_WIDTH/2;
	a[3] -= G_MAP_HEIGHT/2;
}


/*svZA+B*/
matrix aaa(matrix A,matrix B){
	matrix C;
	C.S00=A.S00*B.S00+A.S10*B.S01;
	C.S10=A.S00*B.S10+A.S10*B.S11;
	C.S01=A.S01*B.S00+A.S11*B.S01;
	C.S11=A.S01*B.S10+A.S11*B.S11;
	return C;

}

/*svZ@ts*/
matrix_3 I_3(matrix_3 A){
	matrix_3 B;

	double a[3][3];

	a[0][0]=A.S00;
	a[0][1]=A.S01;
	a[0][2]=A.S02;

	a[1][0]=A.S10;
	a[1][1]=A.S11;
	a[1][2]=A.S12;

	a[2][0]=A.S20;
	a[2][1]=A.S21;
	a[2][2]=A.S22;



	double inv_a[3][3]; 
	double buf; 
	int i,j,k;
	int n=3;  

	for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			inv_a[i][j]=(i==j)?1.0:0.0;
		}
	}

	for(i=0;i<n;i++){
		buf=1/a[i][i];
		for(j=0;j<n;j++){
			a[i][j]*=buf;
			inv_a[i][j]*=buf;
		}
		for(j=0;j<n;j++){
			if(i!=j){
				buf=a[j][i];
				for(k=0;k<n;k++){
					a[j][k]-=a[i][k]*buf;
					inv_a[j][k]-=inv_a[i][k]*buf;
				}
			}
		}
	}

	B.S00=inv_a[0][0];
	B.S01=inv_a[0][1];
	B.S02=inv_a[0][2];

	B.S10=inv_a[1][0];
	B.S11=inv_a[1][1];
	B.S12=inv_a[1][2];

	B.S20=inv_a[2][0];
	B.S21=inv_a[2][1];
	B.S22=inv_a[2][2];


	return B;

}

/*sv@sXV*/
matrix_3 reset_mat_3(){

	matrix_3 A;

	A.S00=0.0;
	A.S01=0.0;
	A.S02=0.0;

	A.S10=0.0;
	A.S11=0.0;
	A.S12=0.0;

	A.S20=0.0;
	A.S21=0.0;
	A.S22=0.0;

	return A;
}

/*svZ@AB@*/
matrix_3 product_mat_3(matrix_3 A,matrix_3 B){

	matrix_3 C;

	double a[3][3];

	a[0][0]=A.S00;
	a[0][1]=A.S01;
	a[0][2]=A.S02;

	a[1][0]=A.S10;
	a[1][1]=A.S11;
	a[1][2]=A.S12;

	a[2][0]=A.S20;
	a[2][1]=A.S21;
	a[2][2]=A.S22;

	double b[3][3];
	b[0][0]=B.S00;
	b[0][1]=B.S01;
	b[0][2]=B.S02;

	b[1][0]=B.S10;
	b[1][1]=B.S11;
	b[1][2]=B.S12;

	b[2][0]=B.S20;
	b[2][1]=B.S21;
	b[2][2]=B.S22;
	double c[3][3];

	for(int i=0;i<3;i++){
		for(int j=0;j<3;j++){
			c[j][i]=0;
			for(int k=0;k<3;k++){
				c[j][i]+=a[j][k]*b[k][i];
			}
		}
	}

	C.S00=c[0][0];
	C.S01=c[0][1];
	C.S02=c[0][2];
	C.S10=c[1][0];
	C.S11=c[1][1];
	C.S12=c[1][2];
	C.S20=c[2][0];
	C.S21=c[2][1];
	C.S22=c[2][2];

	return C;
}


/*֐@cvLineƎg͓*/
void arrow(CvArr* img, CvPoint pt1, CvPoint pt2, CvScalar color,int l,int thickness, int line_type, int shift ){
	CvPoint pt3,pt4;
	double s;
	cvLine (img, pt1, pt2, color, thickness, line_type, shift);
	s = atan2( (double)( pt2.y - pt1.y ), (double)( pt2.x - pt1.x ));
	pt3.y=(int)(-l*sin(s+(15.0)*M_PI/180.0))+pt2.y;
	pt3.x=(int)(-l*cos(s+(15.0)*M_PI/180.0))+pt2.x;
	pt4.y=(int)(-l*sin(s-(15.0)*M_PI/180.0))+pt2.y;
	pt4.x=(int)(-l*cos(s-(15.0)*M_PI/180.0))+pt2.x;
	cvLine (img, pt2, pt3, color, thickness, line_type, shift);
	cvLine (img, pt2, pt4, color, thickness, line_type, shift);

}

/*C[WAC[WBRs[@*/
void show_Image_add(IplImage* A ,IplImage* B ,int s_x,int s_y){


	for (int j= 0; j < (B)->height; j++) {
		for (int i = 0; i < (B)->width; i++) {


			(A)->imageData[(A)->widthStep *(j+s_y)+ (i+s_x)* 3]= (B)->imageData[(B)->widthStep * j + i * 3];
			(A)->imageData[(A)->widthStep *(j+s_y) +(i+s_x)* 3 + 1]=(B)->imageData[(B)->widthStep * j + i * 3 + 1];
			(A)->imageData[(A)->widthStep *(j+s_y) +(i+s_x) * 3 + 2]=(B)->imageData[(B)->widthStep * j + i * 3 + 2];
		}
	}
}

